/*
	dqueue.h -- Data queue primitives.

  Poor Man's Packet (PMP)
  Copyright (c) 1991 by Andrew C. Payne    All Rights Reserved.

  Permission to use, copy, modify, and distribute this software and its
  documentation without fee for NON-COMMERCIAL AMATEUR RADIO USE ONLY is hereby
  granted, provided that the above copyright notice appear in all copies.
  The author makes no representations about the suitability of this software
  for any purpose.  It is provided "as is" without express or implied warranty.

	Andrew C. Payne
	12/03/89
*/

struct dqentry {				/* data queue entry */
	struct dqentry	*next;  	/* next entry */
	int	len;					/* length of this entry */
	byte	data[1];			/* data field */
};

typedef struct dqentry DQUEUE;	/* a data queue */

/* ----- Function Prototypes ----- */
extern void DQInit(DQUEUE *dq);
extern int DQAdd(DQUEUE *dq, byte *data, int len);
extern int DQEmpty(DQUEUE *dq);
extern struct dqentry *DQFirst(DQUEUE *dq);
extern void DQRemoveFirst(DQUEUE *dq);
extern void DQExtract(DQUEUE *dq, byte *dest, int len);
